#include <Ogre.h>
#include <OgreSingleton.h>

#include "GameManager.h"

template<> GameManager* Ogre::Singleton<GameManager>::ms_Singleton = 0;

GameManager::GameManager()
{
  vRoot = NULL;
  vRenderWindow = NULL;
  vState = NULL;
}

GameManager::~GameManager()
{
}

void GameManager::start(GameState *state)
{
  vRoot = new Ogre::Root();

  configure();

  vRoot->addFrameListener(this);

  changeState(state);

  vRoot->startRendering();
}

void GameManager::changeState(GameState *state)
{
  if (vState)
    vState->exit();
  // FIXME : gestion de la mmoire
  vState = state;

  vState->enter();
}

bool GameManager::frameStarted(const Ogre::FrameEvent *evt)
{
  return vState->frameStarted(evt);
}

bool GameManager::frameEnded(const Ogre::FrameEvent *evt)
{
  return vState->frameEnded(evt);
}

GameManager* GameManager::getSingleton()
{
  return ms_Singleton;
}

bool GameManager::configure()
{
  if (!vRoot->restoreConfig())
    {
      if (!vRoot->showConfigDialog())
        {
	  return false;
	}
    }

  vRenderWindow = vRoot->initialise(true);

  Ogre::ResourceGroupManager::getSingleton().initialiseAllResourceGroups();
  return true;
}
