#ifndef _GAMEMANAGER_H
#define _GAMEMANAGER_H

#include <Ogre.h>

#include "GameState.h"

class GameManager : public Ogre::FrameListener,
		    public Ogre::Singleton<GameManager>
{
 public:

  GameManager();
  virtual ~GameManager();

  void start(GameState *state);

  void changeState(GameState *state);

  static GameManager* getSingleton();

private:
  Ogre::Root *vRoot;
  Ogre::RenderWindow *vRenderWindow;

  GameState *vState;

  bool frameStarted(const Ogre::FrameEvent *evt);
  bool frameEnded(const Ogre::FrameEvent *evt);

  bool configure();
};

#endif
